<?php
include("ajax_head.php");

// Übergaben prüfen
if(!is_numeric($_GET['an_konto'])) {
	$status = "error";
	$message = "An-Konto ist ungültig";
} elseif(!is_numeric($_GET['von_konto'])) {
	$status = "error";
	$message = "Von-Konto ist ungültig";
} elseif(empty($_GET['von_konto']) && empty($_GET['an_konto'])) {
	$status = "error";
	$message = "Mindestens ein Konto muss gewählt werden";
} elseif(empty($_GET['name'])) {
	$status = "error";
	$message = "Name fehlt";
} elseif(empty($_GET['betrag']) || !is_numeric(str_replace(",", ".", $_GET['betrag']))) {
	$status = "error";
	$message = "Betrag fehlt oder ist ungültig";
} elseif(!empty($_GET['kategorie']) && !is_numeric($_GET['kategorie'])) {
	$status = "error";
	$message = "Kategorie ist ungültig";
} else {

	// Eingaben abfangen
	$an_konto = floor($_GET['an_konto']);
	$von_konto = floor($_GET['von_konto']);
	$name = $_GET['name'];
	$description = $_GET['description'];
	$betrag = str_replace(",", ".", $_GET['betrag']);
	$kategorie = floor($_GET['kategorie']);
	$datum = empty($_GET['datum']) ? date("Y-m-d") : $_GET['datum'];
	$zeit = empty($_GET['zeit']) ? date("H:i:s") : $_GET['zeit'];
	
	// Prüfen ob die Konten dem User gehören
	if((!empty($von_konto) && $von_konto != 0 && !kontoValid($von_konto)) || (!empty($an_konto) && $an_konto != 0 && !kontoValid($an_konto))) {
		$status = "error";
		$message = "Eines der Konten gehört nicht zu diesem User oder existiert nicht";
	} else {
		
		// Wurde nur ein Konto übergeben?
		if(empty($von_konto) || empty($an_konto) || $von_konto == 0 || $an_konto == 0) {
			// Ermitteln welches übergeben wurde
			if(empty($von_konto)) {
				$konto = $an_konto;
			} else {
				$konto = $von_konto;
				$betrag = $betrag * -1;
			}
			// Buchung speichern
			$result = saveBuchung($konto, $name, $datum, $zeit, $betrag, $description, $kategorie);
			if($result["status"] == "error") {
				$message = "Fehler beim Speichern der Buchung: " . $result["message"];
				$status = "error";
			} else {
				// Alles gut gelaufen. Flag zum übermitteln des Konto-Cache setzen
				$appendCacheData["konten"] = true;
			}
		} elseif($von_konto != $an_konto) {
			// 2 Buchungen erstellen
			if($betrag < 0) {
				$betrag = $betrag * -1;
			}
			$result1 = saveBuchung($an_konto, $name, $datum, $zeit, $betrag, $description, $kategorie);
			if($result1["status"] == "error") {
				$message = "Fehler beim Speichern der 1. Buchung: " . $result1["message"];
				$status = "error";
			} else {
				$id_pos = $result1["id"];
				$betrag = $betrag * -1;
				$result2 = saveBuchung($von_konto, $name, $datum, $zeit, $betrag, $description, $kategorie);
				if($result2["status"] == "error") {
					$message = "Fehler beim Speichern der 2. Buchung: " . $result2["message"];
					$status = "error";
				} else {
					// Beide konnten angelegt werden, Verbindung speichern
					$sql_I3 = "INSERT INTO *PREFIX*md_fibu_connection (`buchung_pos`, `buchung_neg`) VALUES (".$id_pos.", ".$result2["id"].");";
					$res_I3 = query($sql_I3);
					if(isSqlError($res_I3)) {
						$message = "Fehler beim Speichern der Verbindung: " . getSqlError();
						$status = "error";
					} else {
						// Alles gut gelaufen. Flag zum übermitteln des Konto-Cache setzen
						$appendCacheData["konten"] = true;
					}
				}
			}
		}
	}
}

include("ajax_foot.php");
?>