md.fibu.kontoCache = null;

md.fibu.refreshKonten = function() {
	// UI vorbereiten
	$("#grouplist").addClass("loading");
	$(".konto").remove();
	
	var result = null;
	if(md.fibu.kontoCache == null) {
	
		// Daten laden
		var result = md.getValJsonObj("ajax/get_konten.php");
		if(result === false) {
			return;
		}
		
		// Cachen
		md.fibu.kontoCache = result;
	} else {
		// Aus Cache laden
		result = md.fibu.kontoCache;
	}
	
	var data = result.data;
	
	// Gesamtbetrag anzeigen
	$(".overview").html("&Uuml;bersicht <span class=\"utils\">" + md.asColoredEuro(data.gesamt) + "</span>");
	
	// Konten durchlaufen
	for(var i = 0; i < data.konten.length; i++) {
		var konto = data.konten[i];
		
		// Listen-Element vorbereiten
		var li = document.createElement("li");
		li.className = "konto";
		li.id = "konto_" + konto.id;
		
			// Link vorbereiten
			var a = document.createElement("a");
			a.role = "button";
			a.setAttribute('data-id', konto.id);
			
				var span = document.createElement("span");
				span.className = "konto_link";
				span.innerHTML = konto.name;
				a.appendChild(span);
				
				var span2 = document.createElement("span");
				span2.className = "utils";
				span2.innerHTML = md.asColoredEuro(konto.saldo);
				a.appendChild(span2);
			
			li.appendChild(a);
		
		$("#grouplist").append(li);
	}
	
	// Clickhandler anfgen
	$(".konto").on("click", function(e) {
		var id = 0;
		// id ermitteln, je nachdem auf welches Element geklickt wurde
		if(e.target.className == "money_pos" || e.target.className == "money_neg" || e.target.className == "money_neu") {
			id = e.target.parentNode.parentNode.getAttribute('data-id');
		} else if(e.target.className == "konto_link") {
			id = e.target.parentNode.getAttribute('data-id');
		} else {
			id = e.target.getAttribute('data-id');
		}
		md.fibu.getKontoDetails(id);
	});
	
	$("#grouplist").removeClass("loading");
}

md.fibu.getKontoDetails = function(id, year, month) {
	// UI vorbereiten
	$("#app-content").addClass("loading");
	$(".active").removeClass("active");
	$("#konto_" + id).addClass("active");
	$("#app-content").html("");
	
	// Datumsparameter setzen
	var now = new Date();
	year = (typeof year === "undefined") ? now.getFullYear() : year;
	month = (typeof month === "undefined") ? now.getMonth() + 1 : month;
	
	md.fibu.lastKonto = id;
	md.fibu.lastYear = year;
	md.fibu.lastMonth = month;
	
	// Daten laden
	var url = "ajax/konto_details.php?konto=" + id + "&year=" + year + "&month=" + month;
	var result = md.getValJsonObj(url);
	if(result === false) {
		return;
	}
	
	var data = result.data;

	// Tabelle vorbereiten
	var table = document.createElement("table");
	table.id = "item-list";
	
		// Tabellenkopf vorbereiten
		md.fibu.addTableHeader(table, data.konto, data.year, data.month);
		
		// Tabellenkrper vorbereiten
		var tbody = document.createElement("tbody");
		tbody.id = "item-list-body";
		
			// Spalte fr Vormonats-Saldo anlegen
			var tr_vor = document.createElement("tr")
				var td_vor1 = document.createElement("td");
				td_vor1.colSpan = 5;
				td_vor1.innerHTML = "Saldo vom Vormonat:";
				tr_vor.appendChild(td_vor1);
				var td_vor2 = document.createElement("td");
				td_vor2.style.textAlign = "right";
				td_vor2.innerHTML = md.asColoredEuro(data.vormonat);
				tr_vor.appendChild(td_vor2);
				var td_vor3 = document.createElement("td");
				td_vor3.innerHTMl = "&nbsp;";
				tr_vor.appendChild(td_vor3);
			tbody.appendChild(tr_vor);
		
		// Saldo ermitteln
		var saldo = parseFloat(data.vormonat);
		
		// Buchungen durchgehen
		for(var i = 0; i < data.buchungen.length; i++) {
			var buchung = data.buchungen[i];
			
			// Saldo verndern
			saldo += parseFloat(buchung.betrag);
			
			// Buchungszeile anlegen
			var tr = document.createElement("tr")
			md.fibu.addTableField(tr, buchung.id, "left");
			md.fibu.addDateTimeField(tr, buchung.datum, buchung.zeit);
			md.fibu.addNameField(tr, buchung.name, buchung.description, buchung.kategorie_name);
			md.fibu.addTableField(tr, md.asColoredEuro(buchung.betrag), "right");
			md.fibu.addConnectionField(tr, buchung.id, buchung.connection, buchung.created_by);
			md.fibu.addTableField(tr, md.asColoredEuro(saldo), "right");
			md.fibu.addOptionField(tr, buchung.id);
			
			tbody.appendChild(tr);
		}
			
		table.appendChild(tbody);
	
	// UI aktualisieren
	$("#app-content").append(table);
	$("#app-content").removeClass("loading");
}

md.fibu.deleteKonto = function() {

	// Konto-Optionen an Select anhngen
	md.fibu.appendKontoOptions("delete_konto_id", "delete_konto_options");

	// Dialog anzeigen und zentrieren
	md.showAndCenter("delete_konto_dialog");
}
md.fibu.deleteKontoSubmit = function() {
	var form = document.getElementById("delete_konto_form");
	
	// Url basteln
	var url = "ajax/delete_konto.php";
	url += "?id=" + encodeURIComponent(form.delete_konto_id.value);
	
	// bertragen
	if(md.getValJsonObj(url) === false) {
		return;
	}
	
	$("#delete_konto_dialog").css("display", "none");
	md.fibu.refresh();
	form.reset();
}

md.fibu.userCache = null;

md.fibu.newKonto = function() {

	var result = null;
	if(md.fibu.userCache == null) {
		// Url basteln
		var url = "ajax/get_users.php";
		
		// bertragen
		var result = md.getValJsonObj(url);
		if(result === false) {
			return;
		}
		
		// Cachen
		md.fibu.userCache = result;
	} else {
		// Aus dem Cache laden
		result = md.fibu.userCache;
	}
	
	var data = result.data;

	// User-Optionen an Select anhngen
	$(".new_konto_share_user").remove();
	for(var i = 0; i < data.users.length; i++) {
		var option = document.createElement("option");
		option.className = "new_konto_share_user";
		option.value = data.users[i].uid;
		option.innerHTML = data.users[i].uid;
		$("#new_konto_share_user")[0].appendChild(option);
	}

	// Dialog anzeigen und zentrieren
	md.showAndCenter("new_konto_dialog");
	
	// Name-Feld fokussieren
	document.getElementById("new_konto_name").focus();
}
md.fibu.newKontoSubmit = function() {
	var form = document.getElementById("new_konto_form");
	
	// Url basteln
	var url = "ajax/submit_new_konto.php";
	url += "?name=" + encodeURIComponent(form.name.value);
	url += "&info=" + encodeURIComponent(form.info.value);
	url += "&share_user=" + encodeURIComponent(form.share_user.value);
	url += "&inverted=" + encodeURIComponent(form.share_inverted.checked ? "1" : "0");
	url += "&ignore=" + encodeURIComponent(form.ignore.checked ? "1" : "0");
	
	// bertragen
	if(md.getValJsonObj(url) === false) {
		return;
	}
	
	$("#new_konto_dialog").css("display", "none");
	md.fibu.refresh();
	form.reset();
}

md.fibu.editKonto = function() {

	// Konto-Optionen an Select anhngen
	md.fibu.appendKontoOptions("edit_konto_id", "edit_konto_options");

	// Dialog anzeigen und zentrieren
	md.showAndCenter("edit_konto_dialog");
}
md.fibu.getEditKonto = function() {
	var form = document.getElementById("edit_konto_form");
	
	// Url basteln
	var url = "ajax/get_konto.php";
	url += "?id=" + encodeURIComponent(form.edit_konto_id.value);
	
	// bertragen
	var result = md.getValJsonObj(url);
	if(result === false) {
		return;
	}
	
	var data = result.data;
	
	// Formular fllen
	var form = document.getElementById("edit_konto_form");
	
	form.name.value = data.name;
	form.info.value = data.info;
	form.position.value = data.position;
	form.ignore.checked = (data.ignore == 1);
	
	// Formular entsperren
	$(".edit_konto_details").attr('readonly', false);
}
md.fibu.editKontoSubmit = function() {
	var form = document.getElementById("edit_konto_form");
	
	// Url basteln
	var url = "ajax/submit_edit_konto.php";
	url += "?id=" + encodeURIComponent(form.edit_konto_id.value);
	url += "&name=" + encodeURIComponent(form.name.value);
	url += "&info=" + encodeURIComponent(form.info.value);
	url += "&position=" + encodeURIComponent(form.position.value);
	url += "&ignore=" + encodeURIComponent(form.ignore.checked ? "1" : "0");
	
	// bertragen
	if(md.getValJsonObj(url) === false) {
		return;
	}
	
	$("#edit_konto_dialog").css("display", "none");
	md.fibu.refresh();
	form.reset();
}