<?php
include("saldo_functions.php");
include("month_functions.php");
include("buchung_functions.php");
include("konto_functions.php");
include("connection_functions.php");
include("kategorie_functions.php");
include("user_functions.php");

// Wrapper für Datenbankabfragen
function query($sql, $args = NULL) {
	if($args == NULL) {
		$args = array();
	}
	$query = OCP\DB::prepare($sql);
	return $query->execute($args);
}

// Wrapper zum ermitteln der User-ID
function getUID() {
	return OCP\User::getUser();
}

// Wrapper zum laden von SQL-Fehlern
function getSqlError() {
	return OCP\DB::getErrorMessage();
}

// Wrapper zum Prüfen auf SQL-Fehler
function isSqlError($result) {
	return OCP\DB::isError($result);
}

// Wrapper zum Ermitteln der eingefügten ID
function sqlInsertId() {
	return OCP\DB::insertid();
}

// Wrapper zum Starten von Transaktionen
function startTransaction() {
	OCP\DB::beginTransaction();
}

// Wrapper zum Committen von Transaktionen
function commit() {
	OCP\DB::commit();
}

// Wrapper zum Canceln von Transaktionen
function rollBack() {
	$conn = OC::$server->getDatabaseConnection();
	$conn->rollBack();
}

// Prüft ob ein Datum-String ein gültiges Format (YYYY-MM-DD) hat
function dateValid($date) {
	if(strlen($date) != 10) {
		return false;
	}
	$pattern = "/([0-9]{4})-([0-1][0-9])-([0-3][0-9])/";
	$matches = array();
	if(!preg_match($pattern, $date, $matches)) {
		return false;
	}
	if($matches[2] == 0 || $matches[2] > 12) {
		return false;
	}
	if($matches[3] == 0 || $matches[3] > 31) {
		return false;
	}
	return true;
}

// Prüft ob ein Zeit-String ein gültiges Format (HH:MM:SS) hat
function timeValid($time) {
	if(strlen($time) != 8) {
		return false;
	}
	$pattern = "/([0-2][0-9]):([0-5][0-9]):([0-5][0-9])/";
	$matches = array();
	if(!preg_match($pattern, $time, $matches)) {
		return false;
	}
	if($matches[1] > 23) {
		return false;
	}
	return true;
}
?>