<?php
// Gibt den aktuellen Monat zurck
function getThisMonth() {
	return date("Y-m")."-01";
}
// Gibt den letzten Monat zurck
function getLastMonth() {
	return addMonths(getThisMonth(), -1);
}

// Gibt den Monats-String (YYYY-MM-01) des bergebenen Datums zurck
function getMonthFromDate($date) {
	return substr($date, 0, 8)."-01";
}

// Erhht das bergebene Datum um eine bestimmte Anzahl Monate und bercksichtigt Jahrsumbrche
// Negative "Erhhungen" sind ebenfalls mglich
function addMonths($date, $months) {
	$year = substr($date, 0, 4);
	$month = substr($date, 5, 2);
	$newMonth = $month + $months;
	$newYear = $year;
	if($newMonth < 1) {
		$newYear -= 1;
		$newMonth = 12 - $newMonth;
	} elseif($newMonth > 12) {
		$newYear += 1;
		$newMonth = $newMonth - 12;
	}
	if($newMonth < 10) {
		$newMonth = "0".$newMonth;
	}
	return $newYear."-".$newMonth."-01";
}

function closeMonth($konto_id, $month) {

	// bergaben prfen
	if(empty($konto_id) || !is_numeric($konto_id) || $konto_id == 0) {
		return false;
	}
	if(!dateValid($month)) {
		return false;
	}

	// Grenzen festlegen
	$fromMonth = $month;
	$toMonth = addMonths($month, 1);
	
	//Wurde der Monat schon geschlossen?
	$sqlM = "SELECT * FROM *PREFIX*md_fibu_months WHERE konto=? AND month=? LIMIT 0,1";
	$resM = query($sqlM, array($konto_id, $month));
	if($resM->rowCount() == 1) {
		return true;
	}
	
	$vormonat = 0;
	// Wurde der Vormonat schon geschlossen?
	$sqlM = "SELECT * FROM *PREFIX*md_fibu_months WHERE konto=? AND month=? LIMIT 0,1";
	$resM = query($sqlM, array($konto_id, addMonths($month, -1)));
	if($resM->rowCount() == 1) {
		$month2 = $resM->fetchRow();
		$vormonat = $month2['betrag'];
	} else {
		// Wurde berhaupt schon ein Monat geschlossen?
		$sqlM = "SELECT * FROM *PREFIX*md_fibu_months WHERE konto=? LIMIT 0,1";
		$resM = query($sqlM, array($konto_id));
		if($resM->rowCount() == 1) {
			// Ja? Dann erstmal den vorhergehenden rekursiv schliessen
			if(closeMonth($konto_id, addMonths($month, -1))) {
				$vormonat = schlussstandMonth($konto_id, addMonths($month, -1));
			} else {
				return false;
			}
		} else {
			// Nein? Dann ist es das erste Mal
			// Prfen ob es Buchungen vor dem Monat gab
			$sqlB = "SELECT * FROM *PREFIX*md_fibu_buchungen WHERE konto=? AND datum<?";
			$resB = query($sqlB, array($konto_id, $month));
			if($resB->rowCount() == 0) {
				$vormonat = 0;
			} else {
				// Wenn ja, den Vormonat erstmal abschliessen
				if(closeMonth($konto_id, addMonths($month, -1))) {
					// Wenn das geklappt hat, den Abschlussbetrag ermitteln
					$vormonat = schlussstandMonth($konto_id, addMonths($month, -1));
				} else {
					return false;
				}
			}
		}
	}
	
	// Saldo des Konto ermitteln
	$saldo = kontostandMonth($konto_id, $month);
	
	// Saldo speichern
	$sqlI = "INSERT INTO *PREFIX*md_fibu_months (`konto`, `month`, `betrag`) VALUES (?, ?, ?);";
	$resI = query($sqlI, array($konto_id, $month, $saldo*100));
	if(isSqlError($resI)) {
		// rollBack funktioniert mittlerweile, daher muss das hier nicht gemacht werden. Aber zur Sicherheit behalte ich den Code erstmal noch...
		//$sqlD = "DELETE FROM *PREFIX*md_fibu_months WHERE `konto` = ? AND `month` = ? AND `betrag` = ?";
		//$resD = query($sqlD, array($konto_id, $month, $saldo));
		return false;
	} else {
		return true;
	}
}

function performMonthClose() {
	// Monatsabschluss fr alle Konten durchfhren
	
	// Alle Konten des Users laden
	$sqlK = "SELECT * FROM *PREFIX*md_fibu_konten";
	$resK = query($sqlK);
	while($konto = $resK->fetchRow()) {
	
		// Den letzten geschlossenen Monat des Kontos ermitteln
		$sqlM = "SELECT month FROM *PREFIX*md_fibu_months WHERE konto='".$konto['id']."' ORDER BY month DESC LIMIT 0,1";
		$resM = query($sqlM);
		if($resM->rowCount() == 1) {
			$month = $resM->fetchRow();
			// Ist der zuletzt geschlossenen Monat NICHT der Vormonat?
			if($month['month'] != addMonths(date("Y-m-01"), -1)) {
				startTransaction();
				// Den Vormonat und alles was davor lag abschliessen
				if(closeMonth($konto['id'], addMonths(date("Y-m-01"), -1))) {
					commit();
				} else {
					rollBack();
				}
			}
		} else {
			// Wurde noch nie geschlossen
			// Dann alle Buchungen auf dem Konto ermitteln die vor dem aktuellen Monat lagen
			$sqlB = "SELECT * FROM *PREFIX*md_fibu_buchungen WHERE datum<'".date("Y-m-01")."' AND konto='".$konto['id']."'";
			$resB = query($sqlB);
			if($resB->rowCount() > 0) {
				// Wenn es welche gab, dann den Vormonat abschliessen
				startTransaction();
				if(closeMonth($konto['id'], addMonths(date("Y-m-01"), -1))) {
					commit();
				} else {
					rollBack();
				}
			}
		}
	}
}
?>